import bpy
import logging


# TODO: This is for Python logging messages, but do we use it?
#   Only bpx.py use it.
#   Rest of the code use our UserMessage operator.


class LogStreamOff(bpy.types.Operator):
    bl_idname = "ragdoll.logging_off"
    bl_label = "Logging Off"
    bl_options = {"INTERNAL"}
    bl_description = "Stay quiet."

    def execute(self, _):
        log.setLevel(logging.CRITICAL)
        return {"FINISHED"}


class LogStreamDefault(bpy.types.Operator):
    bl_idname = "ragdoll.logging_default"
    bl_label = "Default Logging"
    bl_options = {"INTERNAL"}
    bl_description = ("Print only messages that may be interesting, but "
                      "probably aren't.")

    def execute(self, _):
        log.setLevel(logging.INFO)
        log.info("Info level set")
        return {"FINISHED"}


class LogStreamLess(bpy.types.Operator):
    bl_idname = "ragdoll.logging_less"
    bl_label = "Less Logging"
    bl_options = {"INTERNAL"}
    bl_description = ("Don't print anything unless it's something I need to "
                      "pay attention to.")

    def execute(self, _):
        log.setLevel(logging.WARNING)
        log.warning("Warning level set")
        return {"FINISHED"}


class LogStreamMore(bpy.types.Operator):
    bl_idname = "ragdoll.logging_more"
    bl_label = "More Logging"
    bl_options = {"INTERNAL"}
    bl_description = "Print all messages you can think of."

    def execute(self, _):
        log.setLevel(logging.DEBUG)
        log.debug("Debug level set")
        return {"FINISHED"}


def install():
    bpy.utils.register_class(LogStreamOff)
    bpy.utils.register_class(LogStreamDefault)
    bpy.utils.register_class(LogStreamLess)
    bpy.utils.register_class(LogStreamMore)


def uninstall():
    bpy.utils.unregister_class(LogStreamOff)
    bpy.utils.unregister_class(LogStreamDefault)
    bpy.utils.unregister_class(LogStreamLess)
    bpy.utils.unregister_class(LogStreamMore)
